using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace rtfhtmlEditor
{
    public partial class FormEdit : Form
    {
        FormSpecialChars frmspecialchar = new FormSpecialChars();
        public FormEdit()
        {
            InitializeComponent();
        }
        private void FormEdit_Load(object sender, EventArgs e)
        {
            this.AddOwnedForm(frmspecialchar);

            for (int n = 0; n < System.Drawing.FontFamily.Families.Length; n++)
            {
                this.cbxfontfamily.Items.Add(System.Drawing.FontFamily.Families[n].Name);
            }
            UpdateToolbar(); //Update the toolbar buttons
        }

        private void toolStripButtonCut_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Cut();
        }

        private void cutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Cut();
        }

        private void toolStripButtonCopy_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Copy();
        }

        private void copyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Copy();
        }

        private void toolStripButtonPaste_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Paste();
        }

        private void pasteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Paste();
        }

        private void toolStripButtonDelete_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.SelectedText = "";
        }

        private void toolStripButtonUndo_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Undo();
        }

        private void toolStripButtonRedo_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.Redo();
        }

        private void toolStripButtonBold_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.SelectionFont = new Font(htmlRichTextBox1.SelectionFont, htmlRichTextBox1.SelectionFont.Style ^ FontStyle.Bold);
        }

        private void toolStripButtonItalic_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.SelectionFont = new Font(htmlRichTextBox1.SelectionFont, htmlRichTextBox1.SelectionFont.Style ^ FontStyle.Italic);
        }

        private void toolStripButtonUnder_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.SelectionFont = new Font(htmlRichTextBox1.SelectionFont, htmlRichTextBox1.SelectionFont.Style ^ FontStyle.Underline);
		}

        private void toolStripButtonStrike_Click(object sender, EventArgs e)
        {
            this.htmlRichTextBox1.SelectionFont = new Font(htmlRichTextBox1.SelectionFont, htmlRichTextBox1.SelectionFont.Style ^ FontStyle.Strikeout);
        }

        private void toolStripButtonSuper_Click(object sender, EventArgs e)
        {
            if (this.toolStripButtonSuper.Checked)
            {
                this.htmlRichTextBox1.SetSuperScript(false);
            }
            else
            {
                this.htmlRichTextBox1.SetSuperScript(true);
                this.htmlRichTextBox1.SetSubScript(false);
            }
        	UpdateToolbar(); //Update the toolbar buttons
		}

        private void toolStripButtonSub_Click(object sender, EventArgs e)
        {
            if (this.toolStripButtonSub.Checked)
            {
                this.htmlRichTextBox1.SetSubScript(false); 
            }
            else
            {
                this.htmlRichTextBox1.SetSubScript(true);
                this.htmlRichTextBox1.SetSuperScript(false);
            }
        	UpdateToolbar(); //Update the toolbar buttons
		}

        private void toolStripButtonColor_Click(object sender, EventArgs e)
        {
            colorDialog1.Color = this.htmlRichTextBox1.SelectionColor;
            if (colorDialog1.ShowDialog() == DialogResult.OK)
            {
                this.htmlRichTextBox1.SelectionColor = colorDialog1.Color;
            }
        }

        private void toolStripButtonClearFormat_Click(object sender, EventArgs e)
        {
            string ClearFormat = this.htmlRichTextBox1.Text;
            this.htmlRichTextBox1.Clear();
            this.htmlRichTextBox1.Text = ClearFormat;
        }
        private void toolStripButtonFont_Click(object sender, EventArgs e)
        {
            if (htmlRichTextBox1.SelectionFont != null)
                fontDialog1.Font = htmlRichTextBox1.SelectionFont;
            else
                fontDialog1.Font = htmlRichTextBox1.Font;

            if (fontDialog1.ShowDialog() == DialogResult.OK)
            {
                if (htmlRichTextBox1.SelectionFont != null)
                    htmlRichTextBox1.SelectionFont = fontDialog1.Font;
                else
                    htmlRichTextBox1.Font = fontDialog1.Font;
            }
        }

        private void toolStripButtonSpecialChar_Click(object sender, EventArgs e)
        {
            frmspecialchar.ShowDialog();
        }

        private void cbxfontfamily_SelectedIndexChanged(object sender, EventArgs e)
        {
            string stringfamily = this.cbxfontfamily.SelectedItem.ToString();
            Font nFont = new Font(stringfamily, this.htmlRichTextBox1.Font.Size);
            this.htmlRichTextBox1.SelectionFont = nFont;
        }


		/// <summary>
		///     Update the toolbar button statuses
		/// </summary>
        private void htmlRichTextBox1_SelectionChanged(object sender, EventArgs e)
        {
           if (!htmlRichTextBox1.InternalUpdating)
				UpdateToolbar(); //Update the toolbar buttons
		}
        public void UpdateToolbar()
		{
        			//This is done incase 2 different fonts are selected at the same time
			//If that is the case there is no selection font so I use the default
			//font instead.
			Font fnt;

            if (htmlRichTextBox1.SelectionFont != null)
                fnt = htmlRichTextBox1.SelectionFont;
			else
                fnt = htmlRichTextBox1.Font;

			//Do all the toolbar button checks
			this.toolStripButtonBold.Checked = fnt.Bold; //bold button
            this.toolStripButtonItalic.Checked = fnt.Italic; //italic button
            this.toolStripButtonUnder.Checked = fnt.Underline; //underline button
            this.toolStripButtonStrike.Checked = fnt.Strikeout; //strikeout button
            this.cbxfontfamily.SelectedItem = fnt.FontFamily.Name;  //font family  


            this.toolStripButtonSuper.Checked = htmlRichTextBox1.IsSuperScript();
            this.toolStripButtonSub.Checked = htmlRichTextBox1.IsSubScript();
        }

    }
}